# coding: utf-8
from ._data import *
from ._exceptions import *
from ._path import *
from ._warnings import *
from . import coloring_utils
from . import compress_utils
from . import download_utils
from . import driver_utils
from . import environ_utils
from . import generic_utils
from . import journal_utils
from . import monitor_utils
from . import outfmt_utils
from . import pdf_utils
from . import soup_utils

from .coloring_utils import (toGRAY, toRED, toGREEN, toYELLOW, toBLUE, toPURPLE, 
                             toCYAN, toWHITE, toREVERSE, toACCENT, toFLASH, toRED_FLASH)

from .compress_utils import recreate_dir
from .compress_utils import is_compressed
from .compress_utils import extract_from_compressed

from .download_utils import decide_extension
from .download_utils import download_file
from .download_utils import src2base64
from .download_utils import path2base64
from .download_utils import match2path

from .driver_utils import DRIVER_TYPE
from .driver_utils import get_chrome_options
from .driver_utils import get_driver
from .driver_utils import try_find_element
from .driver_utils import try_find_element_click
from .driver_utils import try_find_element_send_keys
from .driver_utils import pass_forms
from .driver_utils import click
from .driver_utils import download_PDF_with_driver
from .driver_utils import wait_until_all_elements
from .driver_utils import scrollDown

from .environ_utils import name2envname
from .environ_utils import where_is_envfile
from .environ_utils import read_environ
from .environ_utils import write_environ
from .environ_utils import show_environ
from .environ_utils import load_environ
from .environ_utils import check_environ

from .generic_utils import handleKeyError
from .generic_utils import handleTypeError
from .generic_utils import mk_class_get
from .generic_utils import recreate_dir
from .generic_utils import readable_bytes
from .generic_utils import now_str
from .generic_utils import splitted_query_generator
from .generic_utils import get_latest_filename
from .generic_utils import DictParamProcessor
from .generic_utils import ListParamProcessorCreate
from .generic_utils import str_strip
from .generic_utils import try_wrapper

from .journal_utils import whichJournal
from .journal_utils import canonicalize

from .monitor_utils import progress_reporthook_create
from .monitor_utils import ProgressMonitor

from .outfmt_utils import sanitize_filename
from .outfmt_utils import get_jinja_all_attrs
from .outfmt_utils import check_contents
from .outfmt_utils import tohtml
from .outfmt_utils import html2pdf
from .outfmt_utils import toPDF

from .pdf_utils import get_pdf_pages
from .pdf_utils import parser_pdf_pages
from .pdf_utils import get_pdf_contents
from .pdf_utils import createHighlight
from .pdf_utils import addHighlightToPage

from .soup_utils import str2soup
from .soup_utils import split_section
from .soup_utils import group_soup_with_head
from .soup_utils import replace_soup_tag
from .soup_utils import find_target_text
from .soup_utils import find_all_target_text
from .soup_utils import find_target_id
from .soup_utils import kwargs2tag